datablock WheeledVehicleData(Motorcart)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./cart.dts";
	emap = true;
	minMountDist = 3;

	numMountPoints = 5;
	mountNode[0] = 1;
	mountThread[0] = "sit";
	mountNode[1] = 2;
	mountThread[1] = "root";
	mountNode[2] = 3;
	mountThread[2] = "root";
	mountNode[3] = 4;
	mountThread[3] = "root";
	mountNode[4] = 5;
	mountThread[4] = "root";

	maxDamage = 200.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
	//massBox = "2 5 1";

	maxSteeringAngle = 0.8;  // Maximum steering angle, should match animation
	steeringAutoReturn = true;
	steeringAutoReturnRate = 1.2;
	steeringAutoReturnMaxSpeed = 12;
	integration = 8;           // Force integration time: TickSec/Rate
	//tireEmitter = TireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 8;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.3;
	collisionTol = 0.1;        // Collision distance tolerance
	contactTol = 0.1;

	useEyePoint = false;    

	defaultTire    = TrolleyTire;
	defaultSpring    = TrolleySpring;
	flatTire    = TrolleyTire;
	flatSpring    = TrolleySpring;

	numWheels = 4;

	isTrain = 1;

	// Rigid Body
	mass = 300;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;       // Impacts over this invoke the script callback
	softImpactSpeed = 10;      // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 4800;      // Engine power
	engineBrake = 650;        // Braking when throttle is 0
	brakeTorque = 1800;        // When brakes are applied
	maxWheelSpeed = 20;       // Engine scale by current speed / max speed

	rollForce   = 0;
	yawForce    = 0;
	pitchForce    = 0;
	rotationalDrag        = 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = TrolleySplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = TrolleyFoamDropletsEmitter;
	splashEmitter[1] = TrolleyFoamEmitter;
	splashEmitter[2] = TrolleyBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	squealSound = "";
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//explosion = VehicleExplosion;
	justcollided = 0;

	uiName = "Motorcart";
	rideable = true;
	lookUpLimit = 0.65;
	lookDownLimit = 0.45;

	paintable = true;

	damageEmitter[0] = TrolleyBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

	damageEmitter[1] = TrolleyBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

	numDmgEmitterAreas = 1;

	initialExplosionProjectile = TrolleyExplosionProjectile;
	initialExplosionOffset = 0;         //offset only uses a z value for now

	burnTime = 4000;

	finalExplosionProjectile = MotorcartFinalExplosionProjectile;
	finalExplosionOffset = 0.5;          //offset only uses a z value for now

	minRunOverSpeed    = 0.1;   //how fast you need to be going to run someone over (do damage)
	runOverDamageScale = 20;     //when you run over someone, speed * runoverdamagescale = damage amt
	runOverPushScale   = 3;   //how hard a person you're running over gets pushed
};

function Motorcart::onAdd(%this, %obj)
{
	parent::onAdd(%this, %obj);

	%obj.setWheelSteering(0, 1);
	%obj.setWheelSteering(1, 1);
	%obj.setWheelSteering(2, 0);
	%obj.setWheelSteering(3, 0);
}