//customSounds.cs	For engine sounds and any sound not native to BL
//otherSounds.cs	Regular sounds of a vehicle
//server.cs		Vehicle settings, speedcheck
//Support_objects.cs	Things relating to modifying of the actual train(audio+horn+moving)

if(!isObject(TrainExplosionSound))
{
	exec("./otherDB.cs");
}
//----------------------------------------------------------------------------

datablock WheeledVehicleTire(TrolleyTire)
{
	// Tires act as springs and generate lateral and longitudinal
	// forces to move the vehicle. These distortion/spring forces
   	// are what convert wheel angular velocity into forces that
   	// act on the rigid body.
   	shapeFile = "./trolleyWheel.dts";
	
	mass = 10;
	radius = 1;
	staticFriction = 5;
	kineticFriction = 5;
	restitution = 0.5;	

	// Spring that generates lateral tire forces
	lateralForce = 18000;
   	lateralDamping = 4000;
   	lateralRelaxation = 0.01;

	// Spring that generates longitudinal tire forces
	longitudinalForce = 14000;
   	longitudinalDamping = 2000;
   	longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleTire(TrolleyBackTire)
{
	// Tires act as springs and generate lateral and longitudinal
	// forces to move the vehicle. These distortion/spring forces
   	// are what convert wheel angular velocity into forces that
   	// act on the rigid body.
   	shapeFile = "./trolleyWheel.dts";
	
	mass = 10;
	radius = 1;
	staticFriction = 0;
	kineticFriction = 0;
	restitution = 0.5;	

	// Spring that generates lateral tire forces
	lateralForce = 1000;
   	lateralDamping = 400;
   	lateralRelaxation = 0.01;

	// Spring that generates longitudinal tire forces
	longitudinalForce = 1000;
   	longitudinalDamping = 200;
   	longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(TrolleySpring)
{
	// Wheel suspension properties
	length = 0.08;			 // Suspension travel
   	force = 2000; //3000;		 // Spring force
   	damping = 600; //600;		 // Spring damping
   	antiSwayForce = 6; //3;		 // Lateral anti-sway force
};

datablock WheeledVehicleData(Trolley)
{
	category = "Vehicles";
	displayName = " ";
	shapeFile = "./trolley.dts";
	emap = true;
	minMountDist = 3;

	numMountPoints = 16;
	mountThread[0] = "root";
	mountThread[1] = "sit";
	mountThread[2] = "sit";
	mountThread[3] = "sit";
	mountThread[4] = "sit";
	mountThread[5] = "sit";
	mountThread[6] = "sit";
	mountThread[7] = "sit";
	mountThread[8] = "sit";
	mountThread[9] = "root";
	mountThread[10] = "root";
	mountThread[11] = "root";
	mountThread[12] = "root";
	mountThread[13] = "root";
	mountThread[14] = "sit";
	mountThread[15] = "sit";

	maxDamage = 200.00;
	destroyedLevel = 200.00;
	energyPerDamagePoint = 160;
	speedDamageScale = 1.04;
	collDamageThresholdVel = 20.0;
	collDamageMultiplier   = 0.02;

	massCenter = "0 0 0";
	//massBox = "2 5 1";

	maxSteeringAngle = 0.8;  // Maximum steering angle, should match animation
	steeringAutoReturn = true;
	steeringAutoReturnRate = 1.2;
	steeringAutoReturnMaxSpeed = 12;
	integration = 8;           // Force integration time: TickSec/Rate
	//tireEmitter = TireEmitter; // All the tires use the same dust emitter

	// 3rd person camera settings
	cameraRoll = false;         // Roll the camera with the vehicle
	cameraMaxDist = 13;         // Far distance from vehicle
	cameraOffset = 8;        // Vertical offset from camera mount point
	cameraLag = 0.0;           // Velocity lag of camera
	cameraDecay = 0.75;        // Decay per sec. rate of velocity lag
	cameraTilt = 0.3;
	collisionTol = 0.1;        // Collision distance tolerance
	contactTol = 0.1;

	useEyePoint = false;    

	defaultTire    = TrolleyTire;
	defaultSpring    = TrolleySpring;
	flatTire    = TrolleyTire;
	flatSpring    = TrolleySpring;

	numWheels = 6;

	isTrain = 1;

	// Rigid Body
	mass = 300;
	density = 5.0;
	drag = 1.6;
	bodyFriction = 0.6;
	bodyRestitution = 0.6;
	minImpactSpeed = 10;       // Impacts over this invoke the script callback
	softImpactSpeed = 10;      // Play SoftImpact Sound
	hardImpactSpeed = 15;      // Play HardImpact Sound
	groundImpactMinSpeed    = 10.0;

	// Engine
	engineTorque = 4800;      // Engine power
	engineBrake = 650;        // Braking when throttle is 0
	brakeTorque = 1800;        // When brakes are applied
	maxWheelSpeed = 20;       // Engine scale by current speed / max speed

	rollForce   = 0;
	yawForce    = 0;
	pitchForce    = 0;
	rotationalDrag        = 0.2;

	// Energy
	maxEnergy = 100;
	jetForce = 3000;
	minJetEnergy = 30;
	jetEnergyDrain = 2;

	splash = TrolleySplash;
	splashVelocity = 4.0;
	splashAngle = 67.0;
	splashFreqMod = 300.0;
	splashVelEpsilon = 0.60;
	bubbleEmitTime = 1.4;
	splashEmitter[0] = TrolleyFoamDropletsEmitter;
	splashEmitter[1] = TrolleyFoamEmitter;
	splashEmitter[2] = TrolleyBubbleEmitter;
	mediumSplashSoundVelocity = 10.0;   
	hardSplashSoundVelocity = 20.0;   
	exitSplashSoundVelocity = 5.0;
		
	//mediumSplashSound = "";
	//hardSplashSound = "";
	//exitSplashSound = "";
	
	// Sounds
	//jetSound = ScoutThrustSound;
	//engineSound = idleSound;
	squealSound = "";
	softImpactSound = slowImpactSound;
	hardImpactSound = fastImpactSound;
	//wheelImpactSound = slowImpactSound;

	//explosion = VehicleExplosion;
	justcollided = 0;

	uiName = "Trolley";
	rideable = true;
	lookUpLimit = 0.65;
	lookDownLimit = 0.45;

	paintable = true;

	damageEmitter[0] = TrolleyBurnEmitter;
	damageEmitterOffset[0] = "0.0 0.0 0.0 ";
	damageLevelTolerance[0] = 0.99;

	damageEmitter[1] = TrolleyBurnEmitter;
	damageEmitterOffset[1] = "0.0 0.0 0.0 ";
	damageLevelTolerance[1] = 1.0;

	numDmgEmitterAreas = 1;

	initialExplosionProjectile = TrolleyExplosionProjectile;
	initialExplosionOffset = 0;         //offset only uses a z value for now

	burnTime = 4000;

	finalExplosionProjectile = TrolleyFinalExplosionProjectile;
	finalExplosionOffset = 0.5;          //offset only uses a z value for now

	minRunOverSpeed    = 0.1;   //how fast you need to be going to run someone over (do damage)
	runOverDamageScale = 20;     //when you run over someone, speed * runoverdamagescale = damage amt
	runOverPushScale   = 3;   //how hard a person you're running over gets pushed
};

function Trolley::onadd(%this, %obj)
{

	parent::onadd(%this,%obj);
	//Switched to first position so the vehicle is created before it's checked on
	%obj.setWheelSteering(0,1);
	%obj.setWheelSteering(1,1);
	%obj.setWheelSteering(2,0);
	%obj.setWheelSteering(3,0);
	%obj.setWheelSteering(4,0);
	%obj.setWheelSteering(5,0);
	%obj.setWheelSteering(6,0);
	%obj.setWheelSteering(7,0);

	%obj.setWheelPowered(2,false);
	%obj.setWheelPowered(3,false);
	%obj.setWheelPowered(4,false);
	%obj.setWheelPowered(5,false);
	%obj.setWheelPowered(6,false);
	%obj.setWheelPowered(7,false);

	%obj.setWheelTire(2,"TrolleyBackTire");
	%obj.setWheelTire(3,"TrolleyBackTire");
	%obj.setWheelTire(4,"TrolleyBackTire");
	%obj.setWheelTire(5,"TrolleyBackTire");
	%obj.setWheelTire(6,"TrolleyTire");
	%obj.setWheelTire(7,"TrolleyTire");

	%obj.setWheelSpring(6,"TrolleySpring");
	%obj.setWheelSpring(7,"TrolleySpring");
}

//Support_VehicleDismount values
Trolley.dismountOffset[0] = "-2.65 2.46 1.03";
Trolley.dismountOffset[2] = "-2.65 2.46 1.03";
Trolley.dismountOffset[4] = "-2.65 2.46 1.03";
Trolley.dismountOffset[6] = "-2.65 2.46 1.03";
Trolley.dismountOffset[8] = "-2.65 2.46 1.03";
Trolley.dismountOffset[9] = "-2.65 2.46 1.03";
Trolley.dismountOffset[10] = "-2.65 2.46 1.03";
Trolley.dismountOffset[12] = "-2.65 2.46 1.03";
Trolley.dismountOffset[14] = "-2.65 2.46 1.03";

Trolley.dismountOffset[1] = "2.65 2.46 1.03";
Trolley.dismountOffset[3] = "2.65 2.46 1.03";
Trolley.dismountOffset[5] = "2.65 2.46 1.03";
Trolley.dismountOffset[7] = "2.65 2.46 1.03";
Trolley.dismountOffset[11] = "2.65 2.46 1.03";
Trolley.dismountOffset[15] = "2.65 2.46 1.03";

exec("./cart.cs");
exec("./train.cs");